

CREATE TABLE APP.USERS
(
   USER_NAME     VARCHAR(250)   NOT NULL,
   USER_PASS     VARCHAR(1024)   NOT NULL,
   USER_FIRST    VARCHAR(250),
   USER_LAST     VARCHAR(250),
   USER_EMAIL    VARCHAR(250),
   USER_CREATED  VARCHAR(14),
   PRIMARY KEY (USER_NAME)
);

CREATE TABLE APP.USER_ROLES
(
   USER_NAME  VARCHAR(250)   NOT NULL,
   ROLE_NAME  VARCHAR(250)   NOT NULL,
   PRIMARY KEY (USER_NAME, ROLE_NAME)
);
insert into APP.USER_ROLES (user_name, role_name) values ('admin', 'manager-script');
insert into APP.USER_ROLES (user_name, role_name) values ('admin', 'nutzerAdmin');
insert into APP.USER_ROLES (user_name, role_name) values ('admin', 'nutzerProfil');
insert into APP.USER_ROLES (user_name, role_name) values ('admin', 'wbxAdmin');
insert into APP.USER_ROLES (user_name, role_name) values ('admin', 'ownFileAdmin');
insert into APP.USER_ROLES (user_name, role_name) values ('admin', 'sqlKonsole');

create table APP.keytable (
  key_name			varchar(80) not null primary key,
	key_next			int
);
create index key_name_next ON APP.keytable (key_name,key_next);
insert into APP.keytable (key_name, key_next) values ('gr_id',1);
insert into APP.keytable (key_name, key_next) values ('mt_id',1);

create table APP.methoden (
  mt_id       int,
  mt_klasse   varchar(32000),
  mt_name     varchar(32000),
  primary key (mt_id)
);
create index mtkm on APP.methoden (mt_klasse,mt_name);

create table APP.methoden_rechte (
  role_name   varchar(250),
  mt_id       int,
  primary key (role_name,mt_id)
);